CountingInputStream
Date: 2017-02-08

org.apache.commons.compress.utils

## Class CountingInputStream

- java.lang.Object
- - java.io.InputStream
  - - java.io.FilterInputStream
    - - org.apache.commons.compress.utils.CountingInputStream

- All Implemented Interfaces:
    java.io.Closeable, java.lang.AutoCloseable

      public class CountingInputStream
      extends java.io.FilterInputStream

  Stream that tracks the number of bytes read.
  Since:
    1.3

- - ### Field Summary

    - ### Fields inherited from class java.io.FilterInputStream

      `in`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CountingInputStream(java.io.InputStream in)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `count(long read)` Increments the counter of already read bytes.
    `long` | `getBytesRead()` Returns the current number of bytes read from this stream.
    `int` | `read()`
    `int` | `read(byte[] b)`
    `int` | `read(byte[] b, int off, int len)`

    - ### Methods inherited from class java.io.FilterInputStream

      `available, close, mark, markSupported, reset, skip`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CountingInputStream

          public CountingInputStream(java.io.InputStream in)

  - ### Method Detail

    - #### read

          public int read()
                   throws java.io.IOException

      Overrides:
        `read` in class `java.io.FilterInputStream`
      Throws:
        `java.io.IOException`

    - #### read

          public int read(byte[] b)
                   throws java.io.IOException

      Overrides:
        `read` in class `java.io.FilterInputStream`
      Throws:
        `java.io.IOException`

    - #### read

          public int read(byte[] b,
                 int off,
                 int len)
                   throws java.io.IOException

      Overrides:
        `read` in class `java.io.FilterInputStream`
      Throws:
        `java.io.IOException`

    - #### count

          protected final void count(long read)

      Increments the counter of already read bytes. Doesn't increment if the EOF has been hit (read == -1)
      Parameters:
        `read` - the number of bytes read

    - #### getBytesRead

          public long getBytesRead()

      Returns the current number of bytes read from this stream.
      Returns:
        the number of read bytes